; Monopolio, v. 0.33 (NetLogo 4.0 or above)
; NB this is an alpha version, to be completed

globals [x whole_price_list marginal_revenue_list marginal_revenue_list_ma monopolist_p
         expected_q cycle_# monopolist_gain0 monopolist_gain future_price_correction
         future_price_correction0]

breed [consumers consumer]

consumers-own [q price_list]

;-------------------------
to cancel
;; (for this model to work with NetLogo's new plotting features,
  ;; __clear-all-and-reset-ticks should be replaced with clear-all at
  ;; the beginning of your setup procedure and reset-ticks at the end
  ;; of the procedure.)
  __clear-all-and-reset-ticks
set-default-shape consumers "person"
set cycle_# 0
set monopolist_gain0 0
set future_price_correction 0
end

;-------------------------
to setup

cancel

create-consumers consumer_number
ask consumers [fd 10]

set monopolist_p random-float max_p

foreach n-values shop_n [?]
  [ask (patch random-pxcor random-pycor)
    [set pcolor lime] ]

end

;-------------------------
to random_choose_monopolist_p
set monopolist_p monopolist_p + (random-float p_correction_range) - (p_correction_range / 2)
if monopolist_p <= 0 [set monopolist_p 0.1]
if monopolist_p >= max_p [set monopolist_p max_p]
end ;to random_choose_monopolist_p

;-------------------------
to compute_expected_q

if monopolist_chooses_p [
                          set monopolist_p monopolist_p + future_price_correction
                          if monopolist_p <= 0 [set monopolist_p 0.1]
                          if monopolist_p >= max_p [set monopolist_p max_p]
                          ]

set expected_q 0
foreach n-values length whole_price_list [?]
  [if item ? whole_price_list >= monopolist_p [set expected_q expected_q + 1]]

set x expected_q

set monopolist_gain monopolist_p * expected_q - tc

set future_price_correction0 future_price_correction

if monopolist_gain >= monopolist_gain0
   [
     if future_price_correction0 >= 0 [set future_price_correction random-float (p_correction_range /  2)]
     if future_price_correction0 <  0 [set future_price_correction -1 * random-float (p_correction_range /  2)]
     ]
if monopolist_gain <  monopolist_gain0
   [
     if future_price_correction0 >= 0 [set future_price_correction -1 * random-float (p_correction_range / 2)]
     if future_price_correction0 <  0 [set future_price_correction random-float (p_correction_range /  2)]
     ]

set monopolist_gain0 monopolist_gain

end ;to compute_expected_q

;-------------------------
to run_consumers
if (cycle_# mod 10 = 0) [

ask consumers [
  set heading random 360
  fd random 5
  ]

fix_q_in_consumers

build_demand_curve

] ; closing the block, starting with the "if" line
  ; at the beginning of the procedure

set cycle_# cycle_# + 1
end ;to run_consumers

;-------------------------
to fix_q_in_consumers
ask consumers [
  set q (random max_q) + 1
  set price_list n-values q
    [random-float max_p]
  set price_list sort-by [?1 > ?2] price_list
  ]

set-current-plot "quantities"
  set-current-plot-pen "n with q" plot-pen-reset
    histogram [q] of consumers
  set-current-plot-pen "q" plot-pen-reset
    foreach n-values consumer_number [?] [
      ; show q-of consumer ?
      plotxy ? [q] of consumer ?
      ]
end ;to fix_q_in_consumers

;-------------------------
to build_demand_curve

set whole_price_list []
foreach n-values consumer_number [?]
  [set whole_price_list sentence whole_price_list [price_list] of consumer ?
   ;show whole_price_list
  ]
set whole_price_list sort-by [?1 > ?2] whole_price_list
;show whole_price_list

let whole_price_list_ma []
foreach n-values (length whole_price_list - 10) [?]
  [set whole_price_list_ma sentence whole_price_list_ma ((item ?       whole_price_list +
                                                          item (? + 1) whole_price_list +
                                                          item (? + 2) whole_price_list +
                                                          item (? + 3) whole_price_list +
                                                          item (? + 4) whole_price_list +
                                                          item (? + 5) whole_price_list +
                                                          item (? + 6) whole_price_list +
                                                          item (? + 7) whole_price_list +
                                                          item (? + 8) whole_price_list +
                                                          item (? + 9) whole_price_list +
                                                          item (? + 10) whole_price_list)
                                                          / 11 )]
;show whole_price_list_ma

set marginal_revenue_list []
set marginal_revenue_list sentence marginal_revenue_list item 0 whole_price_list
foreach n-values (length whole_price_list - 1) [?]
  [set marginal_revenue_list sentence marginal_revenue_list (((item (? + 1) whole_price_list) * (? + 2)) - ((item (?) whole_price_list) * (? + 1)))]
;show marginal_revenue_list

set marginal_revenue_list_ma [] ; from whole_price_list_ma
set marginal_revenue_list_ma sentence marginal_revenue_list_ma item 0 whole_price_list_ma
foreach n-values (length whole_price_list_ma - 1) [?]
  [set marginal_revenue_list_ma sentence marginal_revenue_list_ma (((item (? + 1) whole_price_list_ma) * (? + 2)) - ((item (?) whole_price_list_ma) * (? + 1)))]
;show marginal_revenue_list_ma

;let marginal_revenue_ma_ [] ; from marginal_revenue_list
;foreach n-values (length marginal_revenue_list - 10) [?]
;  [set marginal_revenue_ma_ sentence marginal_revenue_ma_ ((item ?       marginal_revenue_list +
;                                                           item (? + 1) marginal_revenue_list +
;                                                           item (? + 2) marginal_revenue_list +
;                                                           item (? + 3) marginal_revenue_list +
;                                                           item (? + 4) marginal_revenue_list +
;                                                           item (? + 5) marginal_revenue_list +
;                                                           item (? + 6) marginal_revenue_list +
;                                                           item (? + 7) marginal_revenue_list +
;                                                           item (? + 8) marginal_revenue_list +
;                                                           item (? + 9) marginal_revenue_list +
;                                                           item (? + 10) marginal_revenue_list)
;                                                           / 11 )]
;show marginal_revenue_ma_

set-current-plot "demand curve"

  plot_demand_curve
  plot_marginal_revenue
  plot_marginal_revenue_ma
  compute_expected_q
    plot_exp_q
  plot_monopolist_p
  plot_max_q
  plot_mc
  plot_profit

;  set-current-plot-pen "marginal r. ma_" plot-pen-reset
;  foreach n-values (length marginal_revenue_ma_) [?]
;    [plotxy (? + 6) (item ? marginal_revenue_ma_)]

 end ;to build_demande_curve

;============================================= plotting ======================================

;-------------------------
to plot_demand_curve
  set-current-plot-pen "demand c." plot-pen-reset
  foreach n-values (length whole_price_list) [?]
    [plotxy (? + 1) (item ? whole_price_list)]
end

;-------------------------
to plot_marginal_revenue
  set-current-plot-pen "marginal r." plot-pen-reset
  foreach n-values (length marginal_revenue_list) [?]
    [plotxy (? + 1) (item ? marginal_revenue_list)]
end

;-------------------------
to plot_marginal_revenue_ma
  set-current-plot-pen "marginal r. ma" plot-pen-reset
  foreach n-values (length marginal_revenue_list_ma) [?]
    [plotxy (? + 6) (item ? marginal_revenue_list_ma)]
end

;-------------------------
to plot_mc
wait 0.02 ; used to avoid that the curve would be canceled by the redraw process of the other curves
   set-current-plot-pen "mc" plot-pen-reset
    foreach n-values 300 [?]
      [ set x (? + disp)
        plotxy (? + disp) mc]
end

;-------------------------
to plot_profit
wait 0.02 ; used to avoid that the curve would be canceled by the redraw process of the other curves
  set-current-plot-pen "profit / 100" plot-pen-reset
  foreach n-values (length whole_price_list) [?]
    [set x ? + 1
     plotxy (? + 1) ((item ? whole_price_list) * x - tc) / 100]
end

;-------------------------
to plot_max_q
;wait 0.02 ; used to avoid that the curve would be canceled by the redraw process of the other curves
  set-current-plot-pen "max q." plot-pen-reset
  foreach n-values (max_p + 1) [?]
    [plotxy length whole_price_list ?]
end

;-------------------------
to plot_monopolist_p
  set-current-plot-pen "mon. p." plot-pen-reset
  let xx 0
  foreach n-values 2 [?]
    [if ? > 0 [set xx 310]
     plotxy xx monopolist_p]
end

;-------------------------
to plot_exp_q
wait 0.02 ; used to avoid that the curve would be canceled by the redraw process of the other curves
  set-current-plot-pen "exp. q." plot-pen-reset
  foreach n-values (max_p + 1) [?]
    [plotxy expected_q ?]
end

;============================================= economic functions =============================

;-------------------------
to show_costs

set-current-plot "costs"
  set-current-plot-pen "afc" plot-pen-reset
  foreach n-values 300 [?]
    [ set x (? + disp)
      plotxy (? + disp) afc]
  set-current-plot-pen "avc" plot-pen-reset
  foreach n-values 300 [?]
    [ set x (? + disp)
      plotxy (? + disp) avc]
  set-current-plot-pen "atc" plot-pen-reset
  foreach n-values 300 [?]
    [ set x (? + disp)
      plotxy (? + disp) atc]
  set-current-plot-pen "mc" plot-pen-reset
  foreach n-values 300 [?]
    [ set x (? + disp)
      plotxy (? + disp) mc]
;  set-current-plot-pen "mc_" plot-pen-reset
;  foreach n-values 300 [?]
;    [ set x (? + disp)
;      plotxy (? + disp) mc_]
end ;to show_costs

;-------------------------
to-report fc
  report fc#
end

;-------------------------
to-report afc
  report fc / x
end

;-------------------------
to-report vc
  ifelse no_vc
  [report 0]
  [report 0.00001 * x ^ 3.2 + 10 * x ^ 0.5]
end

;-------------------------
to-report avc
  report vc / x
end

;-------------------------
to-report tc
  report fc + vc
end

to-report atc
  report tc / x
end

;-------------------------
to-report mc ; derivative of tc(x)=fc# + 0.00001x^3.2 + 10x^0.5
             ;              Dtc(x)=      0.000032x^2.2 + 5x^-0.5
  ifelse no_vc
  [report 0]
  [report 0.000032 * x ^ 2.2 + 5 * x ^ -0.5]
end

;-------------------------
to-report mc_ ; we can obtain a close result to the previous one on a pure
              ; numerical calculus basis
  ifelse no_vc
  [report 0]
  [let xx x
   set x x - 0.001
   let tcxx tc
   set x xx ; restoring the value, to avoid rounding effects
   report (tc - tcxx) / 0.001]
end
@#$#@#$#@
GRAPHICS-WINDOW
395
11
691
328
17
17
8.17143
1
10
1
1
1
0
1
1
1
-17
17
-17
17
0
0
1
ticks
30.0

BUTTON
114
158
177
191
NIL
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
31
158
97
191
NIL
cancel
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
208
241
336
274
NIL
run_consumers
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

PLOT
9
406
347
526
quantities
q in consumers
q
0.0
9.0
0.0
5.0
true
true
"" ""
PENS
"q" 1.0 0 -6459832 true "" ""
"n with q" 1.0 1 -955883 true "" ""

SLIDER
34
10
206
43
consumer_number
consumer_number
0
200
100
1
1
NIL
HORIZONTAL

SLIDER
213
10
385
43
max_q
max_q
1
10
5
1
1
NIL
HORIZONTAL

SLIDER
214
49
386
82
max_p
max_p
0
20
10
1
1
NIL
HORIZONTAL

BUTTON
208
199
354
232
NIL
build_demand_curve
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

PLOT
698
10
1160
457
demand curve
q
p
0.0
310.0
0.0
10.0
false
true
"" ""
PENS
"demand c." 1.0 0 -13345367 true "" ""
"marginal r." 1.0 0 -1184463 true "" ""
"marginal r. ma" 1.0 0 -13840069 true "" ""
"marginal r. ma_" 1.0 0 -13791810 true "" ""
"mc" 1.0 0 -2674135 true "" ""
"profit / 100" 1.0 0 -16777216 true "" ""
"max q." 1.0 0 -11221820 true "" ""
"mon. p." 1.0 0 -6459832 true "" ""
"exp. q." 1.0 0 -7500403 true "" ""

SLIDER
33
49
205
82
fc#
fc#
0
200
100
1
1
NIL
HORIZONTAL

SWITCH
403
339
506
372
no_vc
no_vc
1
1
-1000

SLIDER
406
499
578
532
disp
disp
1
20
5
1
1
NIL
HORIZONTAL

PLOT
9
282
346
402
costs
q
costs
1.0
310.0
-1.0
10.0
false
true
"" ""
PENS
"afc" 1.0 0 -16777216 true "" ""
"avc" 1.0 0 -2064490 true "" ""
"atc" 1.0 0 -5825686 true "" ""
"mc" 1.0 0 -2674135 true "" ""
"mc_" 1.0 0 -1184463 true "" ""

BUTTON
31
200
127
233
NIL
show_costs
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
31
242
193
275
run_consumers once
run_consumers
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
784
497
982
530
NIL
random_choose_monopolist_p\n
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

MONITOR
407
446
464
491
NIL
cycle_#
0
1
11

SLIDER
213
94
385
127
shop_n
shop_n
1
20
10
1
1
NIL
HORIZONTAL

BUTTON
209
159
350
192
NIL
fix_q_in_consumers
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

TEXTBOX
585
501
763
540
disp is a technical information, related to the starting point of a few curves
10
15.0
1

SLIDER
34
94
206
127
p_correction_range
p_correction_range
0
4
2
0.1
1
NIL
HORIZONTAL

MONITOR
490
446
592
491
NIL
monopolist_gain
17
1
11

SWITCH
404
389
584
422
monopolist_chooses_p
monopolist_chooses_p
1
1
-1000

@#$#@#$#@
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

link
true
0
Line -7500403 true 150 0 150 300

link direction
true
0
Line -7500403 true 150 150 30 225
Line -7500403 true 150 150 270 225

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 5.3
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180

@#$#@#$#@
0
@#$#@#$#@
